#define ERROR(c,s)  debug_error((W)(c), (B*)(s))

#ifdef DEBUG

#define DUMP(p,l,s) debug_dump((B*)(p), (W)(l), (B*)(s))

#define CHECKPOINT(s) debug_checkpoint(s)
#define ENTRY(s)      debug_entry(s)
#define EXIT(s)       debug_exit(s)

#define SNAP_D(c,s)  snap_dbl((DOUBLE)(c), (B*)(s))
#define SNAP_I(c,s)  snap_int((W)(c), (B*)(s))
#define SNAP_L(c,s)  snap_lng((W)(c), (B*)(s))

#else

#define DUMP(p,l,s) 

#define CHECKPOINT(s) 
#define ENTRY(s)      
#define EXIT(s)       

#define SNAP_D(c,s)
#define SNAP_I(c,s)
#define SNAP_L(c,s)

#endif
