#include <btron/libapp.h>
#include "grapherr.h"
#include "debug.h"

#define MAX_LABEL 24
#define MAX_DATA 8

#define ES_MODIFY    (ES_LSHFT|ES_RSHFT)     /*     */
#define ES_CMND      (ES_CMD|ES_BUT2)        /* ˥塼    */

typedef struct {
  UH column;
  UH row;
} CELL, *CELLPTR;

typedef struct {
  CELL start;
  CELL end;
} AREA, *AREAPTR;

typedef struct {
  DOUBLE max;     /* դκ */
  DOUBLE min;     /* դκǾ */
  DOUBLE scale;   /* ֳ */
} AXIS, *AXISPTR;

// ¹Եǽθͭǡ
typedef struct {
  H len;       // ͭǡĹ = 192
  H bgcol;     // طʿ
  RECT vrect;  // ɥ
  PNT offset;  // ɽ֤Υեå
  H vid;       // ȣɣġ顧̤
  UH type;     // դΥ ʣӷѷ
  UH datatype; // ǡסʣɸࡤȿС
  UW h;        // դʥԥ
  UW v;        // դι⤵ʥԥ
  AXIS axis;   // νļ
  AXIS axis2;  // νļ̤ѡ
  TC area[32]; // ϰϺɸ or ϰ̾
  // ʲϾ
  UW opt;      // ץ̤ѡ
  UW rsv[12];
} FUSEN;

// ü쥢ץꥱ饤֥Ƥǡ
extern W        CHSSTD;   // ɸʸ
extern DEV_SPEC SCREEN;   // ꡼
extern WINFOREC window[]; // ɥ쥳

// ü쥢ץꥱ饤֥Ƥǡܥåؿ
//extern WPTR getdbox();
//extern WPTR ptrdbox();

// ǡܥå
#define DB_SPNL 0x8000    // ñѥͥǡֹ
#define DB_PSTR 0x9000    // ѥͥʸХåեǡֹ
#define DB_MENU 0xA000    // ˥塼ǡֹ
#define DB_SMSG 0xB000    // ƥåǡֹ
#define DB_MISC 0xF000    // ¾Υǡֹ

// ѥͥ
#define ER_OPEN     (DB_SPNL + 1)  // ץ󥨥顼
#define ER_WIND     (DB_SPNL + 2)  // ɥ顼
#define ER_MENU     (DB_SPNL + 3)  // ˥塼顼
#define ER_MEMORY   (DB_SPNL + 4)  // ­顼
#define ER_AREANAME (DB_SPNL + 5)  // ϰ̤̾
#define ER_AREARECT (DB_SPNL + 6)  // ϰϺɸեޥå
#define ER_AREASIZE (DB_SPNL + 7)  // ǡϰϤΥ
#define ER_GRPHSIZE (DB_SPNL + 8)  // ե
#define ER_PASTE    (DB_SPNL + 9)  // ڡȼ

#define PNL_SET   (DB_SPNL + 20) // դ

// ˥塼
#define MENU      (DB_MENU + 0)  // ˥塼

// ¾
#define PAT_PATH  (DB_MISC + 0)

#ifndef DEFINE_TABLE_STRUCT
#define DEFINE_TABLE_STRUCT
// ------------------------------------------
// ơ֥
// ------------------------------------------

// UWORD -> UW
typedef struct {
  UW opt;
  UW row;        // Կ
  UW column;     // 
  UW size;       // ܤΥǡ
  UW offset;     // ǡΰΥեåȡʼºݤϣˤʤ
} TABLE, *TABLEPTR;
#endif

#ifndef DEFINE_LIST_STRUCT
#define DEFINE_LIST_STRUCT
// -------------------------------------
// ̣ɣӣԹ¤Τ
// -------------------------------------

// ꥹȹ
typedef struct item {
  struct item *next; // ΣѣգŤؤΥݥ
  struct item *prev; // ΣѣգŤؤΥݥ
  W id;              // ǡɣ
  W len;             // ǡΥХȥ
  B* dt;             // ǡؤΥݥ
} ITEM;

// ꥹ֥åʣ̣ã¡
typedef struct {
  UW cnt;
  ITEM *head; // ꥹȤΥ
} LIST;
#endif

