#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>
#include <tstring.h>

#include "graph.h"
#include "segment.h"
#include "common.h"
#include "debug.h"

// λ˥塼 (fin_fn() ƤӽФ)
W cmd_close(W mode)
     // mode = 0: ̾1: W_DELETE ׵ */
{
  return 1;
}

// ˥塼
W cmd_gen(W par)
{
  W sts, nlab, ndat;
  TABLE* hTbl = 0;
  TABLE* hDbl = 0;
  TABLE* hGrd = 0;
  AREA dataarea;

  if ((sts = GetArea(myvid, fusen.area, &dataarea)) < 0) {
    ERROR(sts, "cmd_gen[0]");
    if (sts == EA_UNDEF) {
      sts = -1;
    }
    goto exit;
  }
  if ((hTbl = ReadData(myvid, &dataarea, fusen.datatype)) == 0) {
    sts = -1;
    ERROR(sts, "cmd_gen[1]");
    goto exit;
  }
  // ƱΥơ֥
  if ((hDbl = cre_ctb(hTbl, sizeof(DOUBLE))) == 0) {
    sts = -1;
    ERROR(sts, "cmd_gen[2]");
    goto exit;
  }
  if ((sts = s2d_tbl(hDbl, hTbl, fusen.axis.max, fusen.axis.min, fusen.h, 0)) < 0) {
    ERROR(sts, "cmd_gen[3]");
    goto exit;
  }
  if (fusen.datatype == 0) {
    nlab = dataarea.end.row - dataarea.start.row + 1;
    ndat = dataarea.end.column - dataarea.start.column + 1;
  }
  else {
    ndat = dataarea.end.row - dataarea.start.row + 1;
    nlab = dataarea.end.column - dataarea.start.column + 1;
  }
  hGrd = GetGraphScale(&fusen.axis, fusen.v);

  if (fusen.type == 0) {
    // ѷդν
    if ((sts = GenBarGraph2(figdat, nlab, ndat, hDbl, hGrd, &fusen.axis, grect)) < 0) {
      ERROR(sts, "cmd_gen[4]");
      goto exit;
    }
  }
  else {
    // ӷդν
    if ((sts = GenBarGraph1(figdat, nlab, ndat, hDbl, hGrd, &fusen.axis, grect)) < 0) {
      ERROR(sts, "cmd_gen[5]");
      goto exit;
    }
  }
  
 exit:
  if (sts < 0) {
    figdat[0] = TC_NULL;
  }
  if (hGrd != 0) del_tbl(hGrd, FALSE);
  if (hTbl != 0) del_tbl(hTbl, TRUE);
  if (hDbl != 0) del_tbl(hDbl, FALSE);
  return sts;
}

W cmd_genmenu(W par)
{
  W sts;

  sts = cmd_gen(0);
  view(vrect);
  return 0;
}

// ѥͥؿ
#define PNO_TYPE 2
#define PNO_HSIZ 3
#define PNO_VSIZ 4
#define PNO_MAX  5
#define PNO_MIN  6
#define PNO_SCLE 7
#define PNO_DATA 8
#define PNO_AREA 9

W pnl_setfn(W pnid, W item, W v)
{
  W gid, hLst;
  W sts, nlab, ndat;
  W lwk;
  TC* pts;
  TC ts[32];
  AREA area;

  // CHECKPOINT("panel");
  if (item < 0) { // ѥͥν
    lwk = 0L;
  }
  if (item == 1) { // 
    cget_val(pidstdpnl(PNO_TYPE), 1, &lwk);
    fusen.type = lwk - 1;
    cget_val(pidstdpnl(PNO_HSIZ), 2, &lwk);
    if (lwk < 10 || lwk > 1000) {
      dostdpnl(ER_GRPHSIZE, NULL);
      return -1;
    }
    fusen.h = lwk;
    cget_val(pidstdpnl(PNO_VSIZ), 2, &lwk);
    if (lwk < 10 || lwk > 1000) {
      dostdpnl(ER_GRPHSIZE, NULL);
      return -1;
    }
    fusen.v = lwk;
    frect.c.left = fusen.offset.x; // եå
    frect.c.top = fusen.offset.y;  // եå
    frect.c.right = fusen.h + frect.c.left + 5;
    frect.c.bottom = fusen.v + frect.c.top  + 5;
    // *** double* -> W* ؤΥ㥹ȡա ***
    cget_val(pidstdpnl(PNO_MAX),  2, (W*)&fusen.axis.max);
    cget_val(pidstdpnl(PNO_MIN),  2, (W*)&fusen.axis.min);
    cget_val(pidstdpnl(PNO_SCLE), 2, (W*)&fusen.axis.scale);
    cget_val(pidstdpnl(PNO_DATA), 1, &lwk);
    fusen.datatype = lwk - 1;
    cget_val(pidstdpnl(PNO_AREA),32, (W*)fusen.area);
    
    // ʲΥȥʬϰܿȹԤ鷺 (yashiro)
/*
        pts = fusen.area;
        if (!IsArea(pts)) {
            if ((hLst = CreateAreaNameList(myvid)) < 0) {
                dostdpnl(ER_AREANAME, NULL);
                return -1;
            }
            sts = SearchAreaName(hLst, pts, ts);
            del_lst(hLst);
            if (sts < 0) {
                dostdpnl(ER_AREANAME, NULL);
                return -1;
            }
            pts = ts;
        }
        if ((sts = GetAreaVal(pts, &area)) < 0) {
            dostdpnl(ER_AREARECT, NULL);
            return -1;
        }
        if (fusen.datatype == 0) {
            nlab = area.end.row    - area.start.row + 1;
            ndat = area.end.column - area.start.column + 1;
        }
        else {
            ndat = area.end.row    - area.start.row + 1;
            nlab = area.end.column - area.start.column + 1;
        }
        if (nlab > 24 || ndat > 16) {
            dostdpnl(ER_AREASIZE, NULL);
            return -1;
        }
*/
    // պΰ
    setrect(grect, 2, 2, 2+fusen.h, 2+fusen.v);

    return item;
  }
  if (item == 0) { // ѥͥν
    lwk = fusen.type + 1;
    cset_val(pidstdpnl(PNO_TYPE), 1, &lwk);
    lwk = fusen.h;
    cset_val(pidstdpnl(PNO_HSIZ), 2, &lwk);
    lwk = fusen.v;
    cset_val(pidstdpnl(PNO_VSIZ), 2, &lwk);
    cset_val(pidstdpnl(PNO_MAX),  2, (W*)&fusen.axis.max);
    cset_val(pidstdpnl(PNO_MIN),  2, (W*)&fusen.axis.min);
    cset_val(pidstdpnl(PNO_SCLE), 2, (W*)&fusen.axis.scale);
    lwk = fusen.datatype + 1;
    cset_val(pidstdpnl(PNO_DATA), 1, &lwk);
    cset_val(pidstdpnl(PNO_AREA), tc_strlen(fusen.area), (W*)fusen.area);
  }
  return -1; // ѥͥ³
}

// ˥塼
W cmd_set(W par)
{
  if (dostdpnl(PNL_SET, pnl_setfn) == 1) {
    cmd_gen(0);
    view(vrect);
  }
  return 0;
}

// ȥ졼ʣ̥˥塼
W cmd_edit(W par)
{
  // ENTRY("cmd_edit");

  push_tray(grect, figdat, 0);

  // EXIT("cmd_edit");
  
  return 0;
}

// ʪ˥塼
static W cmd_tool(W item)
{
  oexe_apg(0, item); // ʪ¹Ԥ
  return 0;
}

// ˥塼ؿơ֥롧
//   ǡܥå˥塼ֹбؿ

static FUNCP mfunc[] = {
  NULL,         // ȡ¿ȡǥѡ̤
  cmd_tool,     // ʪ˥塼
  NULL,         // ¹ԥ˥塼ѡ̤
  cmd_close,    // ֹ棰ѡʽλ
  cmd_set,      // ֹ棱ѡꡡ
  cmd_edit,     // ֹ棲ѡʥȥ졼ʣ̡
};

#define M_EDIT 2  // Խ˥塼ֹ

/*
    ˥塼٥Ƚʥ˥塼ξ key_fn() ƤФ)
*/
W menu_fn()
{
  W sts;

  // ENTRY("menu_fn");

  // ȤĤʤϡԽ˥塼ǽ֤Ȥ
  inactmenu((UW)(1 << M_EDIT), GRAPHGEN ? M_ACT : M_INACT);

  // ˥塼ưԤ
  sts = selmenu(-1, mfunc);

  // EXIT("menu_fn");

  return sts;
}
