#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>

#include "graph.h"
#include "common.h"

// rpos Ϥ fsnId βȥɥåαƤ
static void drag(PNT rpos)
{
  W dgid, v, typ, sts;
  PNT pos, offset;
  WEVENT evt;
  SEL_RGN sRgn;
  RECT wrec, // ɥåĶΥե졼Ĺ
       vrec;// ɥåĶɽĹ

  if ((dgid = wsta_drg(mywid, 1)) < 0) {
    ERROR(dgid, "drag[1]");
    return;
  }
  setpointer(PS_MOVE, NULL);
  wai_prc(200L);
  setpointer(PS_GRIP, NULL);
  
  gget_fra(dgid, &wrec);
  gget_vis(dgid, &vrec);

  sRgn.sts = 0;
  sRgn.rgn.r = grect;
  offset.x = sRgn.rgn.r.c.left - rpos.x;
  offset.y = sRgn.rgn.r.c.top - rpos.y;
  adsp_sel(dgid, &sRgn, 1);    //  on

  do {
    typ = wget_drg(&pos, &evt);
        
    // Ѳ
    if (typ == 0 && (pos.x != rpos.x || pos.y != rpos.y)) {
      adsp_sel(dgid, &sRgn, 0); //  off

      if (inrect(vrec, pos)) {
        gset_vis(dgid, vrec);
      }
      else {
        gset_vis(dgid, wrec);
      }
      // 
      moverect(&sRgn.rgn.r, pos.x - rpos.x, pos.y - rpos.y);
      rpos = pos;
      adsp_sel(dgid, &sRgn, 1); //  on
    };
  }
  while (typ != EV_BUTUP);

  adsp_sel(dgid, &sRgn, 0); //  off
  wend_drg();
  setpointer(PS_SELECT, NULL);

  // ɥ⡢󥦥ɥΰ衢ޤϥƥåѥͥξ
  if (evt.s.wid == mywid || evt.s.wid <= 0) {
    return;
  }
  // ʳξ
  push_tray(grect, figdat, 1);

  evt.s.pos.x += offset.x;
  if (evt.s.pos.x < 0) evt.s.pos.x = 0;

  evt.s.pos.y += offset.y;
  if (evt.s.pos.y < 0) evt.s.pos.y = 0;

  evt.r.type = EV_REQUEST;
  evt.r.cmd = W_PASTE;
  if ((sts = wsnd_evt(&evt)) < 0) {
    ERROR(sts, "drag[2]");
    return;
  }
  sts = wwai_rsp(NULL, W_PASTE, 5000);
  if (sts == W_ACK) {
    wswi_wnd(evt.s.wid, NULL);
    return;
  }
  dostdpnl(ER_PASTE, NULL);
  return;
};

// ----------------------------------
//  ץ쥹٥Ƚ
// ----------------------------------
W pres_fn(W ix)
{
  W v;
  
  switch(wchk_dck(wevt.s.time)) {
  case W_PRESS: // ץ쥹ν
    if (GRAPHGEN && inrect(grect, wevt.s.pos)) {
      drag(wevt.s.pos);
    }
    break;
  };
  return 0;
}

